// Common/StdOutStream.h

#pragma once 

#ifndef __COMMON_STDOUTSTREAM_H
#define __COMMON_STDOUTSTREAM_H

#define printf	g_StdOut.Printf

class CStdOutStream
{
public:
	BOOL ClearOwnerWindow();
	BOOL SetOwnerWindowEx(HWND hWnd, LPARCHIVERPROC lpArcProc);
	HWND GetOwnerWindow();
	DWORD GetBufSize() { return m_dwBufSize; }	// ݂̕񒷂擾
	LPCSTR CopyBuf(LPSTR lpCopyBuf, DWORD dwBufSize);
	BOOL SetOwnerWindow(HWND hWnd);
	void ReSet();
	HWND GetOutDialogHandle();
	BOOL IsStop() { return m_bStop; }			// ~擾
	BOOL m_bHide;
	DWORD m_dwThreadID;
	HANDLE m_hThread;
	void StopProgress() { m_bStop = TRUE; }		// ~tOZbg
	void Printf(LPCTSTR lpszFormat, ...);
	BOOL SetWindow(HWND hWnd);
	CStdOutStream ();
	~CStdOutStream ();
	
	CStdOutStream & operator<<(CStdOutStream & (* aFunction)(CStdOutStream  &));
	CStdOutStream & operator<<(const char *aChars);
	CStdOutStream & operator<<(char aChar);
	CStdOutStream & operator<<(int aNumber);
	CStdOutStream & operator<<(UINT32 aNumber);
	CStdOutStream & operator<<(UINT64 aNumber);
protected:
	LPARCHIVERPROC m_lpArcProc;
	DWORD m_dwMaxBuf;
	DWORD m_dwBufSize;
	char* m_lpOutBuf;
	HWND m_hOwnerWnd;
	HWND m_hOutWnd;
	BOOL m_bStop;
	void OutProgress(const char* lpszText);
};

CStdOutStream & endl(CStdOutStream & anOut);

extern CStdOutStream g_StdOut;

#endif
